using namespace RooFit ;

void ex16_convolution()
{
  RooWorkspace w("w") ;
  w.factory("Landau::phys(e[0,150],mean[30,0,60],sigma[5,1,10])") ;
  w.factory("Gaussian::resol(e,0,sigma_gauss[10,0.1,20])") ;
  w.factory("FCONV::conv(e,phys,resol)") ;

  RooDataSet* d = w.pdf("conv")->generate(*w.var("e"),1000) ;

  RooFitResult* r = w.pdf("conv")->fitTo(*d,Save(),Timer()) ;

  TCanvas* c = new TCanvas("c","c",1800,600) ;
  c->Divide(3) ;

  c->cd(1) ;
  RooPlot* frame = w.var("e")->frame() ;
  
  d->plotOn(frame) ;

  w.pdf("conv")->fitTo(*d) ;
  w.pdf("conv")->plotOn(frame,VisualizeError(*r)) ;
  w.pdf("conv")->plotOn(frame) ;
  frame->SetMinimum(1e-4) ;
  frame->Draw() ;

  c->cd(3) ;
  
  RooPlot* frame2 = w.var("e")->frame() ;
  w.pdf("phys")->plotOn(frame2,VisualizeError(*r)) ;
  w.pdf("phys")->plotOn(frame2) ;
  frame2->SetMinimum(1e-4) ;
  frame2->Draw() ;

  c->cd(2) ;
  
  w.var("e")->setRange(-75,75) ;
  RooPlot* frame3 = w.var("e")->frame() ;
  w.pdf("resol")->plotOn(frame3,VisualizeError(*r)) ;
  w.pdf("resol")->plotOn(frame3) ;
  frame3->SetMinimum(1e-4) ;
  frame3->Draw() ;

}
